#!/bin/sh
echo ""
echo ""

# Get the directory of this script
END_DIR=`dirname $0`
BEGIN_DIR=`pwd`
if [ "$END_DIR" = "." ]
then
	DIR_SCRIPT="$BEGIN_DIR"
else
	DIR_SCRIPT="$BEGIN_DIR/$END_DIR"
fi
if [ ! -d  "$DIR_SCRIPT" ]
then 
	if [ -d "$END_DIR" ]
	then
		DIR_SCRIPT="$END_DIR"
	else
		DIR_SCRIPT="$BEGIN_DIR"
	fi
fi
JSBROWSER_HOME=$DIR_SCRIPT
cd "${JSBROWSER_HOME}"

TOMCAT_HOME=${JSBROWSER_HOME}/tomcat
JSBROWSER_SAVE_FILE=${JSBROWSER_HOME}/config/jsb3.2.sav
JAVA_EXE=""

invalidUser(){
	echo "You must be root to run this command."
	echo ""
	exit 1	
}

startNetscape(){
    which netscape > /dev/null 2>&1
    if [ "$?" = "0" -a "$DISPLAY" != "" ]
    then
	echo "Trying to launch netscape..."
	echo "If netscape does not start, launch a browser and open the file:"
	echo "file:${JSBROWSER_HOME}/doc/local.html"
	netscape ${JSBROWSER_HOME}/doc/local.html &
    else
	echo "When JSBrowser will be running, launch a browser and open the file:"
	echo "file:${JSBROWSER_HOME}/doc/local.html"
    fi
    echo ""
    echo ""
}


searchJava_EXE(){
	echo "Please wait, searching Java path..."
	# search with the "which" command
	tmppath=`which java 2> /dev/null`
	if [ "$?" = "0" ]
	then
		isValidJavaExe $tmppath
		if [ "$?" = "0" ]
		then
			JAVA_EXE=$tmppath
			echo "Java path found in: $JAVA_EXE"
			return 0
		fi
	fi

	# search in some known directories
	for dir in \
/opt \
/usr
	do
		test -d "$dir"
		if [ "$?" = "0" ] 
		then
			# enter in each subdirs
			LIST=`getAllDir $dir 3`
			for subdir in $LIST
			do
				isValidJavaExe $subdir/java
				if [ "$?" = "0" ]
				then
					JAVA_EXE=$subdir/java
					echo "Java path found in: $JAVA_EXE"
					return 0
				else
					isValidJavaExe $subdir/bin/java
					if [ "$?" = "0" ]
					then
						JAVA_EXE=$subdir/bin/java
						echo "Java path found in: $JAVA_EXE"
						return 0
					fi
				fi
			done		
		fi
	done

	# java not found ask to the user
	echo "Java path not found."	
	echo ""
	echo "Enter the Java 1.2 or 1.3 path, [ENTER] to cancel"
	read javaPath
	while [ "$javaPath" != "" ]
	do
		echo "Please wait, searching Java path..."

		if [ -d "$javaPath" ]
		then
			LIST=`getAllDir $javaPath 1`
			for subdir in $LIST
			do
				isValidJavaExe $subdir/java
				if [ "$?" = "0" ]
				then
					JAVA_EXE=$subdir/java
					echo "JAVA path found in: $JAVA_EXE"
					return 0
				else 					
					isValidJavaExe $subdir/bin/java
					if [ "$?" = "0" ]
					then
						JAVA_EXE=$subdir/bin/java
						echo "JAVA path found in: $JAVA_EXE"
						return 0
					fi
				fi
			done
		else
			if [ -x "$javaPath" ]
			then 
				isValidJavaExe $javaPath
				if [ "$?" = "0" ]
				then
					JAVA_EXE=$javaPath
					echo "Java path found in: $JAVA_EXE"
					return 0
				fi			
			fi
		fi
		echo "Java path not found, try another one"
		echo ""
		echo "Enter the Java 1.2 or 1.3 path, [ENTER] to cancel"
		read jdkPath
	done
	echo "You can download Java 1.3 at http://java.sun.com/j2se/1.3"
	echo "Install it then relaunch: ./JSBrowser.sh"
	exit 1
}

# param1 path
getAllDir(){
	dir1=$1
	LIST=""
	if [ -d "$dir1" ]
	then
	  LIST="$LIST $dir1"
	  for cdir in `ls $dir1`
	  do
	    dir2="$dir1/$cdir"
	    if [ -d "$dir2" ]
	    then
	      LIST="$LIST $dir2"
	      for cdir2 in `ls $dir2`
	      do
	        dir3="$dir2/$cdir2"
	        if [ -d "$dir3" ]
	        then
	          LIST="$LIST $dir3"
	        fi
	      done
	    fi
	  done
	fi
	echo $LIST
}

# test if the $1 java executable is valide
# $1 can be a the javafilename or a directory
# test if the java executable is valid
# return the correct path
isValidJavaExe(){
	if [ ! -x "$1" ]
	then
		return 1
	fi
	
	isOk="1"
	$1 -version >  /tmp/version.$$ 2>&1 
	grep "1\.2" /tmp/version.$$ >  /dev/null 2>&1 
	if [ "$?" = "0" ]
	then
	    isOk="0"
	else 
	    grep "1\.3" /tmp/version.$$ > /dev/null 2>&1
	    if [ "$?" = "0" ]
	    then
			isOk="0"
	    else 	
			grep "1\.4" /tmp/version.$$ > /dev/null 2>&1
			if [ "$?" = "0" ]
			then
			    isOk="0"
			else 	    
			    # Not found
			    isOk="1"  
			fi
	    fi
	fi

	rm -f /tmp/version.$$
	
	if [ "$isOk" = "0" ]
	then
	        PATH=${PATH}:`dirname $1`
		return 0
	else
		echo "$1 program is not the java 1.2 or 1.3 version"
		return 1
	fi
}

getOldJava(){
# try to get the JAVA_EXE in the JSBROWSER_SAVE_FILE file
	touch ${JSBROWSER_SAVE_FILE}  > /dev/null 2>&1 
	java_path=`grep JAVA_EXE ${JSBROWSER_SAVE_FILE}` >  /dev/null 2>&1 
	if [ "$?" = "0" ]
	then
		# found
		tmppath=`echo $java_path | cut -d= -f2`
		isValidJavaExe $tmppath
		if [ "$?" = "0" ]
		then
			JAVA_EXE=$tmppath
			echo "Java path found in: $JAVA_EXE"
			return 0
		fi					
	fi	
	return 1
}

initJSB(){
    searchJava_EXE
    
    # save the JAVA_EXE in JSBROWSER_SAVE_FILE
    echo "JAVA_EXE=${JAVA_EXE}" > ${JSBROWSER_SAVE_FILE}
    
    CLASSPATH=${TOMCAT_HOME}/lib/jaxp.jar:${TOMCAT_HOME}/lib/xmlParserAPIs.jar:${TOMCAT_HOME}/lib/ant.jar:${TOMCAT_HOME}/lib/jasper.jar:${TOMCAT_HOME}/lib/parser.jar:${TOMCAT_HOME}/lib/servlet.jar:${TOMCAT_HOME}/lib/webserver.jar:${TOMCAT_HOME}/webapps/JSBrowser/WEB-INF/classes
    export CLASSPATH
    ${JAVA_EXE} -classpath $CLASSPATH jsb.jsbrowser.InitJSBrowser
}


startJSB(){
    CLASSPATH=${TOMCAT_HOME}/lib/jaxp.jar:${TOMCAT_HOME}/lib/xmlParserAPIs.jar:${TOMCAT_HOME}/lib/ant.jar:${TOMCAT_HOME}/lib/jasper.jar:${TOMCAT_HOME}/lib/parser.jar:${TOMCAT_HOME}/lib/servlet.jar:${TOMCAT_HOME}/lib/webserver.jar
    export CLASSPATH
    ${JAVA_EXE} -Dtomcat.home=${TOMCAT_HOME} -classpath $CLASSPATH org.apache.tomcat.startup.Tomcat &
}


stopJSB(){
    ${TOMCAT_HOME}/bin/tomcat.sh stop
    # sometimes tomcat is not stopped, then kill it
    JSBROWSER=`ps -e | grep tomcat | grep JSBrowser | grep -v grep | awk '{ print $1 }'`
    kill -9 $JSBROWSER > /dev/null 2>&1
}


help(){
    echo ""
    echo ""
    echo " $0 -start"
    echo "    To start JSBrowser."
    echo ""
    echo " $0 -stop"
    echo "    To stop JSBrowser."
}

uid=`id -u`
if [ "${uid}" != "0" ]
then
    invalidUser
fi


if [ "$1" = "-start" ]
then
    echo "JSBrowser is starting..."
    echo "Please wait..."
    getOldJava
    if [ "$?" = "1" ]
    then    
    	initJSB
    fi
    startNetscape
    startJSB    
elif [ "$1" = "-stop" ]
then
    getOldJava
    if [ "$?" = "1" ]
    then    
    	initJSB
    fi
    stopJSB
else 
    help
fi

exit 0
