#!/bin/sh

echo ""
echo ""

JDK_HOME=
JSB_HOME=
PROJECT_ID=
SOURCE_PATH=
EXTERNAL_JAVADOC=


PROJECT_JAVADOC_DIR=${JSB_HOME}/javadoc/${PROJECT_ID}
CLASSPATH=${JSB_HOME}/tomcat/webapps/JSBrowser/WEB-INF/classes

export JDK_HOME
export CLASSPATH


howToSetJdkHome(){
	echo "You need to launch JSBrowser.sh file to initialize JSBrowser."
	echo ""
	echo "If you have not a Java on your host, you can download it at:"
	echo "http://java.sun.com/j2se/1.3, select Java 2 SDK, Standard Edition v1.3"
	echo ""
	exit 1	
}


invalidUser(){
	echo "You must be root to run this command."
	echo ""
	exit 1	
}


uid=`id -u`
if [ "${uid}" != "0" ]
then
	invalidUser
fi

if [ "${JDK_HOME}" = "" ]
then 
	howToSetJdkHome
fi

if [ ! -x "${JDK_HOME}/bin/javadoc" ]
then
	echo "${JDK_HOME}/bin/javadoc not found!"
	echo "You need to install a JDK to be able to generate the java documentation."
	echo ""
	exit 1
fi

if [ ! -x "${JDK_HOME}/bin/java" ]
then
	echo "Error: ${JDK_HOME}/bin/java not found."
	echo ""
	howToSetJdkHome
fi


echo "*********************************************************"
echo "Generate the documentation for ${PROJECT_ID}"
echo "*********************************************************"

cd "${JSB_HOME}"
${JDK_HOME}/bin/java jsb.jsbrowser.javadoc.CreatePrjList ${PROJECT_ID}
if [ "$?" = "1" ]
then
	exit 1
fi

echo ""
echo "Start the javadoc program."

cd ${PROJECT_JAVADOC_DIR} 
${JDK_HOME}/bin/javadoc -J-Xmx512m -private -version -bottom "<center>Generated by JSBrowser</center>" -sourcepath "${SOURCE_PATH}" ${EXTERNAL_JAVADOC} @${PROJECT_JAVADOC_DIR}/packageList.txt

echo "*********************************************************"
echo "Documentation generated for ${PROJECT_ID}"
echo "*********************************************************"

echo ""

exit 0
